package com.s_cradle.improve.client;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;
import java.util.Timer;
import java.util.TimerTask;

/**
 *
 * Ticker \t Improve p Canvas łB
 *
 * @author Masaru Yoshimura
 */
public abstract class ImproveAbstractCanvas extends Canvas{
    public static final int LIST_BG_COLOR = (153<<16) | (153<<8) | 255;
    protected static final int TICKER_HEIGHT = 18;
    public static Ticker ticker;

    public ImproveAbstractCanvas() {
        if( ticker == null ){
            ticker = new Ticker(0,0,getWidth(),TICKER_HEIGHT);
            Timer timer = new Timer();
            TickerTask task = new TickerTask();
            timer.scheduleAtFixedRate(task,200,200);
        }
    }

    private class TickerTask extends TimerTask{
        public void run(){
            ticker.timerExpired();
            repaint();
        }
    }

    /**
     * Õt̋`̕`
     */
    protected static void draw3DRect(Graphics graph, int x, int y, int dx, int dy,
                                   int base, int light, int shadow){
        graph.setColor(base);
        graph.fillRect(x,y,dx,dy);
        graph.setColor(light);
        graph.drawLine(x,y,x + dx - 2,y);
        graph.drawLine(x,y,x,y + dy - 2);
        graph.setColor(shadow);
        graph.drawLine(x + dx - 1,y + 1,x + dx - 1,y + dy - 1);
        graph.drawLine(x + 1,y + dy - 1,x + dx - 1,y + dy - 1);
        return;
    }
}
