package com.s_cradle.improve.client;

import java.io.DataInputStream;
import java.io.IOException;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * bZ[W\NXłBB
 *
 * @author Masaru Yoshimura
 */
public class Message {
    public static final int FROM_ME = 0;
    public static final int FROM_OTHER = 1;

    private String account;
    private int type;
    private String content;
    private int from;

    /**
     * DataInputStream ̍\zB(FBp)
     */
    public Message(DataInputStream input) throws IOException{
        account = input.readUTF();
        type = input.readInt();
        content= input.readUTF();
        from = FROM_OTHER;
    }

    /**
     * String̍\z({lp)
     */
    public Message(String target, String content_){
        account = target;
        content = content_;
        from = FROM_ME;
    }

    // getter

    public String getAccount(){
        return account;
    }

    public int getType(){
        return type;
    }

    public String getContent(){
        return content;
    }

    public int getFrom(){
        return from;
    }
}