package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.net.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *  
 * Iy[V add NXłB
 * HTTPImproveServletɐڑAp[^[œnꂽIy[V
 * 𔭍s܂B̂Ƃ̃fobOo͂HTMLƂďo͂܂B
 *
 * @author Itaru Ogawa
 */
public class Test extends GetOperation {

    /**
     * parameters  add vp[^[܂B
     */
    protected Test() {
        parameters = new String[]{
            Constants.PARAMETER_PATH
        };
    }

    /**
     * GET\bhŃNGXg󂯂̏łB
     * HTMLo͗p̃Xg[ɃfobOo͂肩܂B
     */
    public int processGet(HttpServletRequest req, HttpServletResponse res) 
        throws IOException
    {
        int ret;
        String path = req.getParameter(Constants.PARAMETER_PATH);
        res.setContentType(Constants.CONTENT_TYPE_HTML);
        res.setHeader(Constants.HEADER_CACHE_CONTROL, Constants.HEADER_DATA_NO_CACHE);
        res.setHeader(Constants.HEADER_PRAGMA, Constants.HEADER_DATA_NO_CACHE);
        ImproveServlet.out.println(" path = "+path);

        ImproveServlet.out.println(" changing output!!");
        PrintStream temp = null;
        try {
            ImproveServlet.out = new PrintStream(res.getOutputStream());
            ImproveServlet.out.println("<h1>Test Response</h1> ");          
            ImproveServlet.out.println("<hr /> ");          
            ImproveServlet.out.println("<pre>");
            temp = ImproveServlet.out;
            String query = req.getQueryString();
            testOperation(req.getRequestURL(), path, query.substring(query.indexOf("&")+1));
            ImproveServlet.out.println("</pre>");
            ImproveServlet.out.println("<hr /> ");                  
            ret = 1;
        } catch (IOException ioe) {
            PrintWriter writer = new PrintWriter(new OutputStreamWriter(temp));
            ioe.printStackTrace(writer);
            ret = -1;
        } finally {
            if (temp != null) {
                temp.close();
            }
            ImproveServlet.out = System.out;
        }
        return ret;
    }

    /**
     * HTPPImproveServletɐڑ܂B
     */
    private void testOperation(StringBuffer base, String path, String query) throws IOException {
        base.replace(base.lastIndexOf("/"), base.length(),path);
        base.append("?");
        base.append(query);
        URL url = new URL(base.toString());
        System.err.println(url);
        HttpURLConnection http = (HttpURLConnection)url.openConnection();
        http.setRequestMethod("GET");
        DataInputStream input = new DataInputStream(http.getInputStream());
        int result = input.readInt();
        input.close();
        ImproveServlet.out.println(" received result= "+result);
    }

}
