package com.s_cradle.improve;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *  
 * T[o[ƃNCAgŋL萔`Ă܂B
 *
 * @author Itaru Ogawa
 */
public interface Constants {
    // e[uɓ镶̍ő咷
    public static final int ACCOUNT_MAX = 10;
    public static final int PASSWORD_MAX = 10;
    public static final int NICKNAME_MAX = 9;
    public static final int PHONENUMBER_MAX = 11;
    public static final int DESCRIPTION_MAX = 20;
    public static final int MESSAGE_MAX = 64;

    // vgRppX
    public static final String OPERATION_CREATE  = "/create";
    public static final String OPERATION_DELETE  = "/delete";
    public static final String OPERATION_ADD     = "/add";
    public static final String OPERATION_REMOVE  = "/remove";
    public static final String OPERATION_SET     = "/set";
    public static final String OPERATION_SEND    = "/send";
    public static final String OPERATION_POLLING = "/polling";
    public static final String OPERATION_CHECK   = "/check";
    public static final String OPERATION_TEST   =  "/test";

    // p[^
    public static final String PARAMETER_ACCOUNT  = "account";
    public static final String PARAMETER_PASSWORD = "password";
    public static final String PARAMETER_TARGET   = "target";
    public static final String PARAMETER_ITEM     = "item";
    public static final String PARAMETER_TYPE     = "type";
    public static final String PARAMETER_CONTENT  = "content";
    public static final String PARAMETER_PATH     = "path";

    // Content-Type 
    public static final String CONTENT_TYPE_BINARY = "application/octet-stream";
    public static final String CONTENT_TYPE_HTML   = "text/html; charset=Shift_JIS";

    // Chache p
    public static final String HEADER_CACHE_CONTROL = "Cache-Control";
    public static final String HEADER_PRAGMA         = "Pragma";
    public static final String HEADER_DATA_NO_CACHE  = "no-cache";

    // [U[񍀖index
    public static final int ITEM_INDEX_LENGTH      = 6;
    public static final int ITEM_INDEX_ACCOUNT     = 0;
    public static final int ITEM_INDEX_PASSWORD    = 1;
    public static final int ITEM_INDEX_NICKNAME    = 2;
    public static final int ITEM_INDEX_PHONE       = 3;
    public static final int ITEM_INDEX_STATUS      = 4;
    public static final int ITEM_INDEX_DESCRIPTION = 5;

    // [U[񍀖ږ
    public static final String ITEM_NAME_ACCOUNT     = "account";
    public static final String ITEM_NAME_PASSWORD    = "password";
    public static final String ITEM_NAME_NICKNAME    = "nickname";
    public static final String ITEM_NAME_PHONE       = "phone";
    public static final String ITEM_NAME_STATUS      = "status";
    public static final String ITEM_NAME_DESCRIPTION = "description";

    //  (`bgex)
    public static final int STATUS_LOGOFF = 0;
    public static final int STATUS_RED = 1;
    public static final int STATUS_YELLOW = 2;
    public static final int STATUS_BLUE = 3;

    // ږz
    public static final String[] ITEM_COLUMN_NAME = new String[]{
        ITEM_NAME_ACCOUNT,
        ITEM_NAME_PASSWORD,
        ITEM_NAME_NICKNAME,
        ITEM_NAME_PHONE,
        ITEM_NAME_STATUS,
        ITEM_NAME_DESCRIPTION
    };

    // bZ[W^Cv
    public static final int MESSAGE_TYPE_NORMAL = 1;
    public static final int MESSAGE_TYPE_ATTACK = 2;

    /** f[^x[X̃[U[ */
    public static final String USER = "sophia";

    /** f[^x[X̃pX[h */
    public static final String PASSWORD = "cradle";

    /** PostgreSQLpJDBChCo */
    public static final String POSTGRESQL_DRIVER = "org.postgresql.Driver";

    /** PostgreSQLp̐ڑ */
    public static final String POSTGRESQL_CONNECTION
    = "jdbc:postgresql://localhost/improve?user=" + USER + "&password=" + PASSWORD;
}
