package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.net.*;
import java.util.Calendar;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *  
 * Iy[V check NXłB
 *
 * @author Itaru Ogawa
 */
public class Check extends GetOperation {
    private static final String[] TABLE_NAMES = new String[] {
        "users","friends","messages"
    };

    /**
     * parameters  add vp[^[܂B
     */
     protected Check() {
        parameters = new String[]{};
    }

    /**
     * GET\bhŃNGXg󂯂̏łB
     * e[ȗSeHTMLŏo͂܂B
     */
    public int processGet(HttpServletRequest req, HttpServletResponse res) 
        throws IOException
    {
        res.setContentType(Constants.CONTENT_TYPE_HTML);
        res.setHeader(Constants.HEADER_CACHE_CONTROL, Constants.HEADER_DATA_NO_CACHE);
        res.setHeader(Constants.HEADER_PRAGMA, Constants.HEADER_DATA_NO_CACHE);

        PrintWriter out = res.getWriter();
        Connection con = null;
        Statement st = null;
        String sql;
        ResultSet rs = null;
        ResultSetMetaData meta = null;
        int ret = -1;
        
        
        try {
            try {
            // JDBChCõ[hƐڑ
            Class.forName(Constants.POSTGRESQL_DRIVER).newInstance();
            con = DriverManager.getConnection(Constants.POSTGRESQL_CONNECTION);
            } catch (Exception e) {
                e.printStackTrace();
            }
            out.println("<html>");
            out.println("<head><title>improve srever status</title></head>");
            out.println("<body>");
            out.println("<h1>improve server status page</h1> ");

            Calendar calendar = Calendar.getInstance();
            out.println("<p>");
            out.print("current time : ");
            out.print(getCalendarFormatDigit(calendar.get(Calendar.YEAR)) + "/");
            out.print(getCalendarFormatDigit(calendar.get(Calendar.MONTH)+1) + "/");
            out.print(getCalendarFormatDigit(calendar.get(Calendar.DATE)) + " ");
            out.print(getCalendarFormatDigit(calendar.get(Calendar.HOUR_OF_DAY)) + ":");
            out.print(getCalendarFormatDigit(calendar.get(Calendar.MINUTE)) + ":");
            out.println(getCalendarFormatDigit(calendar.get(Calendar.SECOND)));
            out.println("</p>");

            out.println("<hr /> ");


            for (int i=0; i<TABLE_NAMES.length; i++) {
                st = con.createStatement();
                sql = "SELECT * FROM "+TABLE_NAMES[i];
                rs = st.executeQuery(sql);
                meta = rs.getMetaData();
                
                out.println("<table border='1'>");
                out.println("<caption>"+TABLE_NAMES[i]+"</caption>");

                out.println("<tr>");
                for (int j=1; j<=meta.getColumnCount(); j++) {
                    out.println("<th>");
                    out.println(meta.getColumnName(j));
                    out.println(" ("+meta.getColumnTypeName(j)+")");
                    out.println("</th>");
                }
                out.println("</tr>");
                
                while (rs.next()) {
                    out.println("<tr>");
                    for (int j=1; j<=meta.getColumnCount(); j++) {
                        out.println("<td>");
                        out.println(rs.getString(j));
                        out.println("</td>");
                    }
                    out.println("</tr>");               
                }
                out.println("</table>");
                out.println("<hr /> ");             
            out.println("</body>");
                st.close();
            }
            ret = 1;

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            ret = -1;
        } finally {
            out.close();
        }
        return ret;
    }

    static String getCalendarFormatDigit(int i) {
        StringBuffer buf = new StringBuffer();
        if (0 <= i && i <10) {
            buf.append("0");
        }
        buf.append(i);
        return buf.toString();
    }
}
