package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *  
 * Iy[V delete NXłB
 *
 * @author Itaru Ogawa
 */
public class Delete extends GetOperation {

    /**
     * parameters  delete vp[^[܂B
     */
    protected Delete() {
        parameters = new String[]{
            Constants.PARAMETER_ACCOUNT,
            Constants.PARAMETER_PASSWORD
        };
    }

    /**
     * GET\bhŃNGXg󂯂̏łB
     * [U[F؂ɒʂ΁AAJEg폜܂B
     * 폜AJEgɊ֘Aق̃e[u̍s
     * f[^x[X̐ɂ莩폜܂B
     */
    public int processGet(HttpServletRequest req, HttpServletResponse res) 
        throws IOException
    {
        String account   = req.getParameter(Constants.PARAMETER_ACCOUNT);
        String password = req.getParameter(Constants.PARAMETER_PASSWORD);
        String sql;
        int ret = -1;
        ImproveServlet.out.println(" account = "+account);
        ImproveServlet.out.println(" password = "+password);
        Connection con = null;
        Statement st = null;

        try {
            // JDBChCõ[hƐڑ
            Class.forName(Constants.POSTGRESQL_DRIVER).newInstance();
            con = DriverManager.getConnection(Constants.POSTGRESQL_CONNECTION);


            if (isAuthorized(account, password)) {// Fؐ
                // AJEg폜
                st = con.createStatement();
                sql = "DELETE FROM users WHERE account='"+account+ "'AND password='" +password+ "'";
                ImproveServlet.out.println(" executeUpdate : "+sql);
                st.executeUpdate (sql);
                st.close();

                ret = account.length(); 
            }

            con.close();
            st = null;
            con = null;

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            ImproveServlet.out.println(" EXCEPTION : "+sqle);
            ret = -1;

        } finally {
            try {
                if (st!=null) {
                    st.close();
                }
                if (con!=null) {
                    con.close();
                }
            } catch (SQLException sqle2) {
                sqle2.printStackTrace();
                ImproveServlet.out.println(" EXCEPTION : "+sqle2);
            }

            res.setContentType(Constants.CONTENT_TYPE_BINARY);
            DataOutputStream out = new DataOutputStream(res.getOutputStream());
            out.writeInt(ret);
            res.setContentLength(out.size());
            out.close();
            ImproveServlet.out.println(" result = "+ret);
            return ret;
        }
    }

}
